Index: target/linux/generic-2.6/config-2.6.32
===================================================================
--- target/linux/generic-2.6/config-2.6.32	(revision 23991)
+++ target/linux/generic-2.6/config-2.6.32	(working copy)
@@ -2401,7 +2401,8 @@
 # CONFIG_UIO is not set
 # CONFIG_ULTRIX_PARTITION is not set
 # CONFIG_UNEVICTABLE_LRU is not set
-# CONFIG_UNION_MOUNT is not set
+#&&&
+CONFIG_UNION_MOUNT=y
 CONFIG_UNIX98_PTYS=y
 # CONFIG_UNIXWARE_DISKLABEL is not set
 CONFIG_UNIX=y
Index: target/linux/x86/base-files/lib/upgrade/platform.sh
===================================================================
--- target/linux/x86/base-files/lib/upgrade/platform.sh	(revision 23991)
+++ target/linux/x86/base-files/lib/upgrade/platform.sh	(working copy)
@@ -26,8 +26,14 @@
 	# partition that points to the active rootfs partition.
 	# however this only matters if we actually need to preserve the config files
 	[ "$SAVE_CONFIG" -eq 1 ] || return 0
+	#&&& hb9xar: need ROOTFS here as well...
+	local ROOTFS
+	grep -q -e "jffs2" -e "squashfs" /proc/cmdline \
+		&& ROOTFS="$(awk 'BEGIN { RS=" "; FS="="; } ($1 == "block2mtd.block2mtd") { print substr($2,1,index($2, ",")-1) }' < /proc/cmdline)" \
+		|| ROOTFS="$(awk 'BEGIN { RS=" "; FS="="; } ($1 == "root") { print $2 }' < /proc/cmdline)"
+
 	grep rootfs /proc/mtd >/dev/null || {
-		echo /dev/hda2,65536,rootfs > /sys/module/block2mtd/parameters/block2mtd
+		echo /dev/${ROOTFS},65536,rootfs > /sys/module/block2mtd/parameters/block2mtd
 	}
 }
 append sysupgrade_pre_upgrade x86_prepare_ext2
Index: package/hostapd/files/wpa_supplicant.sh
===================================================================
--- package/hostapd/files/wpa_supplicant.sh	(revision 23991)
+++ package/hostapd/files/wpa_supplicant.sh	(working copy)
@@ -104,6 +104,7 @@
 	config_get ssid "$vif" ssid
 	config_get bssid "$vif" bssid
 	bssid=${bssid:+"bssid=$bssid"}
+	[ "$proto" != "" ] && proto1="proto=$proto" || proto1=""
 	rm -rf /var/run/wpa_supplicant-$ifname
 	cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
 ctrl_interface=/var/run/wpa_supplicant-$ifname
@@ -112,7 +113,7 @@
 	ssid="$ssid"
 	$bssid
 	key_mgmt=$key_mgmt
-	$proto
+	$proto1
 	$ieee80211w
 	$passphrase
 	$pairwise
@@ -131,6 +132,9 @@
 	$wep_tx_keyidx
 }
 EOF
-	[ -z "$proto" -a "$key_mgmt" != "NONE" ] || \
-		wpa_supplicant ${bridge:+ -b $bridge} -B -P "/var/run/wifi-${ifname}.pid" -D ${driver:-wext} -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
+#&&& start wpa_supplicant in any case - non-encrypted connection just means 
+#&&& that wpa_supplicant has to take care of automatic reassociating
+#&&&	[ -z "$proto" -a "$key_mgmt" != "NONE" ] || \
+#&&&		wpa_supplicant ${bridge:+ -b $bridge} -B -P "/var/run/wifi-${ifname}.pid" -D ${driver:-wext} -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
+	wpa_supplicant ${bridge:+ -b $bridge} -B -P "/var/run/wifi-${ifname}.pid" -D ${driver:-wext} -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
 }
Index: package/base-files/files/lib/functions/boot.sh
===================================================================
--- package/base-files/files/lib/functions/boot.sh	(revision 23991)
+++ package/base-files/files/lib/functions/boot.sh	(working copy)
@@ -77,11 +77,52 @@
 fopivot() { # <rw_root> <ro_root> <dupe?>
 	root=$1
 	{
-		if grep -q mini_fo /proc/filesystems; then
-			mount -t mini_fo -o base=/,sto=$1 "mini_fo:$1" /mnt 2>&- && root=/mnt
+		#&&& disable minifo /hb9xar
+		if grep -q mini_foXXX /proc/filesystems; then
+ 			mount -t mini_fo -o base=/,sto=$1 "mini_fo:$1" /mnt 2>&- && root=/mnt
+#// not impl.	else if grep -q aufs /proc/filesystems; then
 		else
-			mount --bind / /mnt
-			mount --bind -o union "$1" /mnt && root=/mnt 
+			# - Mount the base read-only file system as
+			#   the root file system - done way before here
+			# - Mount the read-only file system again
+			#   on /mnt
+ 			mount --bind / /mnt
+			# - Mount the writable overlay on /mnt:
+ 			mount --bind -o union "$1" /mnt && root=/mnt 
+			# - pivot_root to /newroot - done below
+
+			if [ "$root" = "/mnt" ]; then
+			# hb9xar: symlink /var -> /tmp needs a "kick"...
+			#rm -rf /mnt/var && ln -s /tmp/ /mnt/var
+			# actually ALL symlinks in RO layer to an
+			# outside fs (/tmp/) do not work.
+			#
+			# The following magic does find all symlinks
+			# pointing from / into /tmp/.
+			# A=link, B=link target in /tmp/
+			# This must include symlinks into /var/, as /var
+			# itself is linked into /tmp...
+			echo "fixing up symlinks for UNION MOUNT..."
+			for each in 	`find $root -xdev -type l 2>/dev/null | \
+					xargs ls -al | tr -s ' ' | \
+					cut -d ' ' -f 9- | \
+					egrep "(\-> /tmp|-> /var/)" | \
+					sed -e "s|$root\(.*\) -> \(.*\)|A=\"\1\";B=\"\2\";|"`;
+			do
+				eval $each
+				# now check if this particular link is existing
+				# in /overlay (jffs2 fs), if not we need to recreate
+				# it in the UNION (/mnt)
+				if ls /overlay/$A 2>/dev/null | grep -q /overlay/; then
+					echo "$A -> $B is ok."
+				else
+
+					# need to recreate in RW layer...
+					echo "$A -> $B has been recreated."
+					rm -rf $root/$A; ln -s $B $root/$A
+				fi
+			done
+			fi
 		fi
 	} || {
 		[ "$3" = "1" ] && {
@@ -95,5 +136,6 @@
 ramoverlay() {
 	mkdir -p /tmp/root
 	mount -t tmpfs root /tmp/root
-	fopivot /tmp/root /rom 1
+#&&&xar	fopivot /tmp/root /rom 1
+	fopivot /tmp/root /rom
 }
Index: package/base-files/files/lib/firstboot/30_no_fo_pivot
===================================================================
--- package/base-files/files/lib/firstboot/30_no_fo_pivot	(revision 23991)
+++ package/base-files/files/lib/firstboot/30_no_fo_pivot	(working copy)
@@ -5,7 +5,8 @@
 
 no_fo_pivot() {
     # switch to the new (empty) jffs2
-    fopivot /overlay /rom 1
+#&&&xar to be changed to /overlay /rom 0 ??
+    fopivot /overlay /rom 0
 }
 
 boot_hook_add no_fo no_fo_pivot
Index: package/base-files/files/lib/firstboot/20_has_mini_fo
===================================================================
--- package/base-files/files/lib/firstboot/20_has_mini_fo	(revision 23991)
+++ package/base-files/files/lib/firstboot/20_has_mini_fo	(working copy)
@@ -4,7 +4,8 @@
 # Copyright (C) 2010 Vertical Communications
 
 check_for_mini_fo() {
-    if ! grep -q mini_fo /proc/filesystems; then
+#&&&xar disable mini_fo
+    if ! grep -q mini_foXXX /proc/filesystems; then
 	boot_run_hook no_fo
 	exit 1
     fi
Index: package/base-files/files/lib/firstboot/10_reset_has_mini_fo
===================================================================
--- package/base-files/files/lib/firstboot/10_reset_has_mini_fo	(revision 23991)
+++ package/base-files/files/lib/firstboot/10_reset_has_mini_fo	(working copy)
@@ -4,7 +4,8 @@
 # Copyright (C) 2010 Vertical Communications
 
 reset_check_for_mini_fo() {
-    if grep -q mini_fo /proc/filesystems; then
+#&&&xar disable mini_fo
+    if grep -q mini_foXXX /proc/filesystems; then
 	reset_has_fo=true
     fi
 }
Index: package/base-files/files/etc/profile
===================================================================
--- package/base-files/files/etc/profile	(revision 23991)
+++ package/base-files/files/etc/profile	(working copy)
@@ -13,3 +13,5 @@
 
 [ -x /sbin/arp ] || arp() { cat /proc/net/arp; }
 [ -z /bin/ldd ] || ldd() { LD_TRACE_LOADED_OBJECTS=1 $*; }
+
+alias ll='ls -al'
Index: package/base-files/files/etc/config/network
===================================================================
--- package/base-files/files/etc/config/network	(revision 23991)
+++ package/base-files/files/etc/config/network	(working copy)
@@ -7,8 +7,13 @@
 	option netmask	255.0.0.0
 
 config interface lan
-	option ifname	eth0
-	option type 	bridge
-	option proto	static
-	option ipaddr	192.168.1.1
-	option netmask	255.255.255.0
+	option type     bridge
+	option ifname   "eth0 eth1"
+	option proto    dhcp
+#	option ipaddr   192.168.101.1
+#	option netmask  255.255.255.0
+
+config interface wlan
+	option proto    static
+	option ipaddr   10.0.0.1
+	option netmask  255.255.255.0
Index: package/base-files/files/etc/sysctl.conf
===================================================================
--- package/base-files/files/etc/sysctl.conf	(revision 23991)
+++ package/base-files/files/etc/sysctl.conf	(working copy)
@@ -22,3 +22,7 @@
 net.bridge.bridge-nf-call-arptables=0
 net.bridge.bridge-nf-call-ip6tables=0
 net.bridge.bridge-nf-call-iptables=0
+
+# HAMNET: disable IPV6 by default on all interfaces
+net.ipv6.conf.all.disable_ipv6=1
+
Index: package/base-files/files/sbin/sysupgrade
===================================================================
--- package/base-files/files/sbin/sysupgrade	(revision 23991)
+++ package/base-files/files/sbin/sysupgrade	(working copy)
@@ -51,8 +51,11 @@
 
 add_uci_conffiles() {
 	local file="$1"
+	# Config files to save across an upgrade
 	find /etc/config /etc/passwd /etc/group /etc/dropbear \
-		/etc/firewall.user /etc/rc.local -type f > "$file"
+		/etc/firewall.user /etc/rc.local \
+		/etc/quagga /etc/ntp.conf \
+		-type f > "$file"
 	return 0
 }
 
Index: package/dnsmasq/files/dhcp.conf
===================================================================
--- package/dnsmasq/files/dhcp.conf	(revision 23991)
+++ package/dnsmasq/files/dhcp.conf	(working copy)
@@ -18,9 +18,7 @@
 
 config dhcp lan
 	option interface	lan
-	option start 	100
-	option limit	150
-	option leasetime	12h
+	option ignore	1
 
 config dhcp wan
 	option interface	wan
Index: package/crda/Makefile
===================================================================
--- package/crda/Makefile	(revision 23991)
+++ package/crda/Makefile	(working copy)
@@ -60,6 +60,10 @@
 	NLLIBS="-lnl-tiny -lm" \
 	REG_BIN="$(DL_DIR)/$(PKG_REGULATORY_SOURCE)" \
 	crda
+#&&&
+define Build/Configure
+	cp files/HAMNET_OWRT.key.pub.pem $(PKG_BUILD_DIR)/pubkeys/
+endef
 
 define Package/crda/install
 	$(INSTALL_DIR) $(1)/sbin
@@ -68,7 +72,8 @@
 	$(INSTALL_DIR) $(1)/usr/lib/crda
 	$(INSTALL_BIN) $(PKG_BUILD_DIR)/crda $(1)/sbin/
 	$(INSTALL_DATA) ./files/hotplug.rule $(1)/etc/hotplug.d/platform/10-regulatory
-	$(INSTALL_DATA) $(DL_DIR)/$(PKG_REGULATORY_SOURCE) $(1)/usr/lib/crda/regulatory.bin
+#&&&	$(INSTALL_DATA) $(DL_DIR)/$(PKG_REGULATORY_SOURCE) $(1)/usr/lib/crda/regulatory.bin
+	$(INSTALL_DATA) ./files/regulatory.bin $(1)/usr/lib/crda/regulatory.bin
 endef
 
 $(eval $(call BuildPackage,crda))
Index: package/kernel/modules/other.mk
===================================================================
--- package/kernel/modules/other.mk	(revision 23991)
+++ package/kernel/modules/other.mk	(working copy)
@@ -506,6 +506,42 @@
 $(eval $(call KernelPackage,leds-alix))
 
 
+#&&&
+define KernelPackage/leds-alix2
+  SUBMENU:=$(OTHER_MENU)
+  TITLE:=PCengines ALIX2 LED support
+  DEPENDS:=@TARGET_x86
+  KCONFIG:=CONFIG_LEDS_ALIX2
+  FILES:=$(LINUX_DIR)/drivers/leds/leds-alix2.$(LINUX_KMOD_SUFFIX)
+  AUTOLOAD:=$(call AutoLoad,50,leds-alix2)
+endef
+
+define KernelPackage/leds-alix2/description
+ Kernel module for PCengines ALIX2 LEDs
+endef
+
+$(eval $(call KernelPackage,leds-alix2))
+
+
+#&&&
+define KernelPackage/ledtrig-ide-disk
+  SUBMENU:=$(OTHER_MENU)
+  TITLE:=LED IDE DISK Trigger
+  KCONFIG:= \
+        CONFIG_LEDS_TRIGGER_IDE_DISK=y \
+        CONFIG_IDE_GD_ATA=y \
+        CONFIG_IDE_GD=y
+  FILES:=$(LINUX_DIR)/drivers/leds/ledtrig-ide-disk.$(LINUX_KMOD_SUFFIX)
+  AUTOLOAD:=$(call AutoLoad,50,ledtrig-ide-disk)
+endef
+
+define KernelPackage/ledtrig-ide-disk/description
+ Kernel module to drive LEDs based on IDE disk activity.
+endef
+
+$(eval $(call KernelPackage,ledtrig-ide-disk))
+
+
 define KernelPackage/leds-wndr3700-usb
   SUBMENU:=$(OTHER_MENU)
   TITLE:=WNDR3700 USB LED support
Index: package/mac80211/files/lib/wifi/mac80211.sh
===================================================================
--- package/mac80211/files/lib/wifi/mac80211.sh	(revision 23991)
+++ package/mac80211/files/lib/wifi/mac80211.sh	(working copy)
@@ -395,6 +395,13 @@
 		[ -n "$type" ] || break
 		devidx=$(($devidx + 1))
 	done
+#&&& backward compatibility - used "phy<x>" in the past
+	while :; do
+		config_get type "phy$devidx" type
+		[ -n "$type" ] || break
+		devidx=$(($devidx + 1))
+	done
+
 	for dev in $(ls /sys/class/ieee80211); do
 		found=0
 		config_foreach check_device wifi-device
